/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#include <Connection/ConnectorFactory.hpp>
#include <Connection/ScenarioLoaderConnector.hpp>
#include <Connection/ScenarioRecorderConnector.hpp>
#include <Connection/SDSConnector.hpp>
#include <Connection/DAConnector.hpp>

using namespace Dxc;

DxcConnector* ConnectorFactory::getDAConnector(DxcCallback* callback)
{
    return new DAConnector(callback);
}

DxcConnector* ConnectorFactory::getSDSConnector(DxcCallback* callback)
{
    return new SDSConnector(callback);
}

DxcConnector* ConnectorFactory::getScenarioLoaderConnector(DxcCallback* callback)
{
    return new ScenarioLoaderConnector(callback);
}

DxcConnector* ConnectorFactory::getScenarioRecorderConnector(DxcCallback* callback)
{
    return new ScenarioRecorderConnector(callback);
}
