/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#include <DataTypes/ErrorData.hpp>

using namespace Dxc;
using namespace std;

ErrorData::ErrorData(Timestamp timestamp, const string& error)
        : DxcData(timestamp)
{
    string::size_type n = 0;

    while (n != string::npos)
    {
        string::size_type m = error.find_first_of('\'', n);
        if (m != string::npos)
        {
            error_ += error.substr(n, m - n);
            if (error_[error_.length()-1] == '\\')
                error_ += "'";
            else
                error_ += "\\'";
            m++;
        }
        else
        {
            error_ += error.substr(n);
        }
        n = m;
    }
}

string ErrorData::getError() const
{
    return error_;
}

ErrorData* ErrorData::clone() const
{
    return new ErrorData(*this);
}

ostream &ErrorData::put(ostream &out) const
{
    out << "error @" << this->getTimeStamp() << " "
    << "'" << error_ << "';" << endl;
    return out;
}
