/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef LITERAL_HPP
#define LITERAL_HPP

#include <iostream>
#include <string>

#include <DxcDefs.hpp>

#include "Value.hpp"

using namespace std;

namespace Dxc
{

class DXCAPI_EXPORT Literal
{
public:
    Literal(const string *, const Value *);

public:
    const string *getId() const;
    const Value *getValue() const;

private:
    const string *id_;
    const Value *value_;
};

}

ostream DXCAPI_EXPORT & operator << (ostream &, const Dxc::Literal *);

#endif
