/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia
  
  The DXC Framework is free software: you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by the 
  Free Software Foundation, either version 3 of the License, or (at your 
  option) any later version. 

  This program is distributed in the hope that it will be useful, but WITHOUT 
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
  details. 

  You should have received a copy of the GNU Lesser General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/> 
 */
package org.dxc.api.datatypes;

import java.io.PrintStream;

/**
 * Error message.
 */
public class ErrorData extends DxcData {

    private String error;

    /**
     * Constructor.
     * 
     * @param timestamp
     *            - message time.
     * @param error
     *            - string describing the error.
     */
    public ErrorData(long timestamp, String error) {
        super(timestamp);
        if (error == null)
            this.error = "";
        else
            this.error = error.replaceAll("[^\\\\]'", "\\\\'");
    }

    /**
     * Returns the error message string.
     */
    public String getError() {
        return error;
    }

    public PrintStream put(PrintStream out) {
        out.append("error @");
        out.append(Long.toString(this.getTimeStamp()));
        out.append(" '" + error + "';\n");
        return out;
    }
}