/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia
  
  The DXC Framework is free software: you can redistribute it and/or modify it 
  under the terms of the GNU Lesser General Public License as published by the 
  Free Software Foundation, either version 3 of the License, or (at your 
  option) any later version. 

  This program is distributed in the hope that it will be useful, but WITHOUT 
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more 
  details. 

  You should have received a copy of the GNU Lesser General Public License 
  along with this program. If not, see <http://www.gnu.org/licenses/> 
 */
package org.dxc.standaloneSDS;

import org.dxc.api.datatypes.DxcData;
import org.dxc.api.connection.DxcConnector;
import org.dxc.api.DxcCallback;

;

public class ForwardMessageCallback extends DxcCallback {
    private DxcConnector connector;

    private long previousTime = -1;

    private long previousDataTime = -1;

    public ForwardMessageCallback(DxcConnector connector) {
        this.connector = connector;
    }

    public void processData(DxcData data) {
        if (previousTime < 0) {
            previousTime = System.currentTimeMillis();
            previousDataTime = data.getTimeStamp();
        }

        long tDelta = data.getTimeStamp() - previousDataTime;

        if (tDelta > 0) {
            try {
                long st = tDelta - System.currentTimeMillis() + previousTime;
                if (st > 0)
                    Thread.sleep(st);
            } catch (Exception ex) {
                System.out.append(ex.getMessage());
            }
        }

        previousDataTime = data.getTimeStamp();
        data.setTimeStamp(System.currentTimeMillis());
        previousTime = data.getTimeStamp();

        connector.sendMessage(data);
    }
}
