/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_LINUXEXELOADER_HPP
#define DXC_LINUXEXELOADER_HPP

#include <string>
#include <sys/times.h>

#include <ProcessLoader.hpp>

using namespace std;

namespace Dxc
{

class LinuxExeLoader : public ProcessLoader
{
public:
    LinuxExeLoader(const string &,
                   const string &,
                   const string &);

    void start();
    bool isRunning();
    void terminate();
    unsigned long getCpuTime();
    unsigned long getPeakMemoryUsage();
    virtual bool timedWait(long);

    ~LinuxExeLoader();

private:
    string exe_, path_, args_;
    int pid_;

    struct tms startTime;
    struct tms endTime;

    string getError();
};

}

#endif
