/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifndef DXC_PROCESSLOADER_H
#define DXC_PROCESSLOADER_H

namespace Dxc
{

class ProcessLoader
{
public:
    virtual void start() = 0;
    virtual bool isRunning() = 0;
    virtual void terminate() = 0;
    virtual unsigned long getCpuTime() = 0;
    virtual unsigned long getPeakMemoryUsage() = 0;

    virtual bool timedWait(long) = 0;

    virtual ~ProcessLoader() {};
};

}

#endif
