/*
  DXC Framework (http://dx-competition.org/)
  Copyright 2008 David Garcia

  The DXC Framework is free software: you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by the
  Free Software Foundation, either version 3 of the License, or (at your
  option) any later version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
  details.

  You should have received a copy of the GNU Lesser General Public License
  along with this program. If not, see <http://www.gnu.org/licenses/>
*/
#ifdef _WIN32

#ifndef DXC_WINEXELOADER_HPP
#define DXC_WINEXELOADER_HPP

#include <string>
#include <vector>
#include <Windows.h>
#include <ProcessLoader.hpp>

namespace Dxc
{

class WinExeLoader : public ProcessLoader
{
public:
    WinExeLoader(const std::string &exeName,
                 const std::string &path,
                 const std::string &args);

    void start();
    bool isRunning();
    void terminate();
    unsigned long getCpuTime();
    unsigned long getPeakMemoryUsage();
    virtual bool timedWait(long);

    ~WinExeLoader();

private:
    std::string exe_, path_, args_;
    PROCESS_INFORMATION procinfo_;

    std::string getError();
};

}

#endif
#endif
